Package com.smartgwt.client.types

# Enum TreeModelType

java.lang.Object
java.lang.Enum<TreeModelType>
com.smartgwt.client.types.TreeModelType

All Implemented Interfaces:
  `ValueEnum`, `Serializable`, `Comparable<TreeModelType>`, `Constable`

public enum TreeModelType extends Enum<TreeModelType> implements ValueEnum

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `CHILDREN`
  In this model, nodes specify their children as a list of nodes.
  `PARENT`
  In this model, each node has an ID unique across the whole tree and a parent ID that points to its parent.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getValue()`
  `static TreeModelType`
  `valueOf(String name)`
  Returns the enum constant of this type with the specified name.
  `static TreeModelType[]`
  `values()`
  Returns an array containing the constants of this enum type, in the order they are declared.

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### PARENT

    public static final TreeModelType PARENT
    In this model, each node has an ID unique across the whole tree and a parent ID that points to its parent. The name of the unique ID property can be specified via `Tree.idField` and the name of the parent ID property can be specified via `Tree.parentIdField`. The initial set of nodes can be passed in as a list to `Tree.data` and also added as a list later via `Tree.linkNodes()`. Whether or not a given node is a folder is determined by the value of the property specified by `Tree.isFolderProperty`.
    The "parent" modelType is best for integrating with relational storage (because nodes can map easily to rows in a table) and collections of Beans and is the model used for DataBound trees.

    If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "parent".

  - ### CHILDREN

    public static final TreeModelType CHILDREN
    In this model, nodes specify their children as a list of nodes. The property that holds the children nodes is determined by `Tree.childrenProperty`. Nodes are not required to have an ID that is unique across the whole tree (in fact, no ID is required at all). Node names (specified by the `Tree.nameProperty`, unique within their siblings, are optional but not required. Whether or not a given node is a folder is determined by the presence of the children list (`Tree.childrenProperty`).

    If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "children".

- ## Method Details

  - ### values

    public static TreeModelType[] values()
    Returns an array containing the constants of this enum type, in the order they are declared.
    Returns:
      an array containing the constants of this enum type, in the order they are declared

  - ### valueOf

    public static TreeModelType valueOf(String name)
    Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum type has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### getValue

    public String getValue()
    Specified by:
      `getValue` in interface `ValueEnum`